﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var accident:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		private var sc_x:Number;
		private var sc_y:Number;
		private var rpx:Number;
		private var rpy:Number;
		
		private var cur:Number;
		private var rot:Number;
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			setup();
		}
		private function setup():void
		{
			max			= 2000;
			fibonacci	= 1/1.1;
			accident	= 0;
			rapport 	= 360-90*fibonacci - 10;
			rad 		= 130;
			growth		= 1.004;
			//sc_x		= 200;
			//sc_y		= 200;
			rpx			= 20;
			rpy			= 1.70;
		
			cur			= max;
			rot			= -10;
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.CLICK,click_handler);
			//stage.addEventListener(MouseEvent.MOUSE_OVER,up_handler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			setup();
			removeEventListener(Event.ENTER_FRAME,enterhandler);
		}
		
		
		
		private function click_handler(e:MouseEvent):void
		{
			graphics.clear();
			setup();
			addEventListener(Event.ENTER_FRAME, enterhandler);
		}
		
		
		
		private function enterhandler(e:Event):void
		{
			if(cur)
			{
				cur--;
				rapport-=accident;
				sc_x*=rpy;
				sc_y*=rpx;
				rot += rapport;
				rot-= new int(rad/90)*360;
				rad/=growth;
				var x:Number = mouseX+Math.cos(rot * Math.PI/90) *rad;
				var y:Number = mouseY+Math.sin(rot * Math.PI/90) *rad;
				if(cur!= (max-1)){
					graphics.lineStyle(1,0x999999,.7);
					graphics.lineTo(x,y);
					//rotation= Math.random()*360;
					graphics.drawCircle(x,y,2);
				}else{
					graphics.moveTo(x,y);
				}
			}else{
				removeEventListener(Event.ENTER_FRAME,enterhandler);
			}
		}
		
	}
}